package csir.helloworld.seam;

import java.io.Serializable;
import java.util.List;

import javax.interceptor.Interceptors;
import javax.ejb.Remove;
import javax.ejb.Stateful;
import javax.persistence.EntityManager;

import org.apache.log4j.Logger;
import org.jboss.seam.annotations.Create;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.datamodel.DataModel;
import org.jboss.seam.ejb.SeamInterceptor;

import csir.helloworld.par.HelloWorldEntity;


/**
 * Stateful bean to view previously persisted entity beans
 * @author  <a href="mailto:louis.coetzee@csir.co.za">Louis Coetzee</a>
 *
 */
@Stateful
@Name("viewBean")
public class ViewBean implements Serializable, View {

	static final Logger logger = Logger.getLogger(ViewBean.class);

	@In(create = true, value = "jaasExampleEntityManager")
	EntityManager em;

	@DataModel
	List<HelloWorldEntity> allHelloWorlds;

	public ViewBean() {
	}

	@Create
	public void theBegin() {
		logger.info("Created");
	}

	@Destroy
	@Remove
	public void theEnd() {
		logger.info("Removed");
	}

	@Factory("allHelloWorlds")
	public String loadHelloWorlds() {

		allHelloWorlds = em.createQuery(
				"from csir.helloworld.par.HelloWorldEntity").getResultList();
		return "loaded";
	}

}
