package csir.user.seam;

import java.io.Serializable;
import java.util.List;
import java.util.ArrayList;

import javax.interceptor.Interceptors;
import javax.ejb.Stateless;
import javax.faces.context.FacesContext;
import javax.persistence.EntityManager;

import org.jboss.seam.Seam;

import org.apache.log4j.Logger;
import org.jboss.seam.InterceptionType;
import org.jboss.seam.annotations.Begin;
import org.jboss.seam.annotations.Conversational;
import org.jboss.seam.annotations.Create;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.annotations.End;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Intercept;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.datamodel.DataModel;
import org.jboss.seam.annotations.datamodel.DataModelSelectionIndex;
import org.jboss.seam.ejb.SeamInterceptor;

import csir.user.par.PortalRole;
import csir.user.par.PortalUser;

@Stateless
@Name("logoutBean")
public class LogoutBean implements Logout, Serializable {
	/**
	 * nothing
	 */
	private static final long serialVersionUID = 1500435921212997441L;

	static final Logger logger = Logger.getLogger(LogoutBean.class);

	 
	@In(create = false)
	private transient FacesContext facesContext;

	@In(create=true)
	@Out(required=true, scope=ScopeType.SESSION)
	private PortalUser portalUser;


	private PortalRole portalRole;

	
	public LogoutBean() {
		logger.info("LogoutBean started");
	}


	public String logout() {
		portalUser = new PortalUser();
		logger.info("logout");
		try {
			Seam.invalidateSession();
		}
		catch ( Throwable t ) {
			logger.error("logout throws " + t);
		}
		return "logout";
	}

}
